

# Disvide 🔧

[![PyPI version](https://badge.fury.io/py/disvide.svg)](https://badge.fury.io/py/disvide)
[![Discord server](https://img.shields.io/discord/983326447970172978.svg?label=Discord&logo=Discord&colorB=7289DA&style=flat)](https://discord.gg/uqbxCTfxX9)

Disvide is a Discord bot generator that allows you to create a bot by answering a few questions. This project is created by Cored, Inc and led by FSCYT.

## Table of Contents

- [Disvide 🔧](#disvide-)
  - [Table of Contents](#table-of-contents)
  - [🚀 Features](#-features)
  - [📋 Prerequisites](#-prerequisites)
  - [📦 Installation](#-installation)
  - [🎉 Getting Started](#-getting-started)
  - [🆕 Updates](#-updates)
  - [🤝 Contributing](#-contributing)
  - [🐛 Issues](#-issues)
  - [💻 Windows Installation](#-windows-installation)
  - [📄 License](#-license)

## 🚀 Features

- Command handler
- Event handler
- Slash command handler
- Sub-commands handler
- TypeScript and JavaScript support
- Command categories
- Easy customizability

Please note that these are the features of the bot that is generated by Disvide, not the features of Disvide itself.

## 📋 Prerequisites

Before using Disvide, make sure you have the following:

- Python 3.6 or higher installed on your system.
- `pip` package manager installed on your system.
- A Discord account with access to the developer portal.

In addition, your system should meet the following requirements:

- At least 2 GB of RAM.
- At least 1 GHz CPU.
- At least 100 MB of free storage space.

Please note that you can run this app with lower-tier hardware, but you may experience performance issues.

## 📦 Installation

To get started with Disvide, follow these steps:

1. Clone this repository to your local machine.
2. Install the required dependencies by running `pip install -r requirements.txt`.

## 🎉 Getting Started

To generate a Discord bot with Disvide, follow these steps:

1. Create a Discord bot account and obtain the bot token from the Discord Developer Portal.
2. Run the program by executing `python bot_generator.py` in your terminal.
3. Answer the following questions to generate your bot:
   - What is the username of your bot?
   - What is the token of your bot?
   - What is the client ID of your bot?
   - What is the client secret of your bot?
   - Which programming language do you want to use (TS or JS)?

The program will then generate a Discord bot for you.

## 🆕 Updates

18/04/2023

- Re-wrote templates for all languages respectively to support all the listed features above.
- Made huge progress on the command generator part of disvide.
- Other minor changes...

## 🤝 Contributing

Contributions to Disvide are welcome! If you would like to contribute, follow these steps:

1. Fork this repository.
2. Create a new branch with your changes: `git checkout -b my-feature-branch`.
3. Commit your changes: `git commit -m "Added a new feature"`.
4. Push to the branch: `git push origin my-feature-branch`.
5. Create a pull request.

## 🐛 Issues

If you encounter any issues while using Disvide, please report them on the [issues page](https://github.com/cored-developments-2023/disvide/issues). To create a new issue, follow these steps:

1. Click on the "Issues" tab in the repository.
2. Click on the "New Issue" button.
3. Provide a descriptive title and detailed description of the issue.
4. Click on the "Submit new issue" button.

## 💻 Windows Installation

For installing Disvide on Windows (8.1/10/11 preferably), it will be a bit more advanced due to Windows being as advanced as always. Here are the steps that you must follow to get access to Disvide on Windows:

1. Clone this git repository by running `git clone https://github.com/Cored-Inc/Disvide`
2. Go into the Disvide directory, run `pip install -r requirements.txt` to install the packages required
3. Run `pip install --editable .`
4. Enjoy using disvide by running `disvide` on the terminal.

*Ran into issues even after that? Create an issue using the above guide and we will try our best to help you out!*

## 📄 License

This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.